# matrix-appservice-kakaotalk - A Matrix-KakaoTalk puppeting bridge.
# Copyright (C) 2022 Tulir Asokan, Andrew Ferrazzutti
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
"""Custom wrapper classes around types defined by the KakaoTalk API."""

from attr import dataclass

from mautrix.types import SerializableAttrs

from ..types.channel.channel_info import NormalChannelInfo
from ..types.openlink.open_channel_info import OpenChannelInfo
from ..types.user.channel_user_info import NormalChannelUserInfo, OpenChannelUserInfo


ChannelInfoUnion = NormalChannelInfo | OpenChannelInfo
UserInfoUnion = NormalChannelUserInfo | OpenChannelUserInfo

@dataclass
class PortalChannelInfo(SerializableAttrs):
    name: str
    #participants: list[PuppetUserInfo]
    # TODO Image
    channel_info: ChannelInfoUnion | None = None # Should be set manually by caller
